#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <math.h>
class massiv
{   int *y;
    int m;
  public:
    massiv();
    massiv(int*, int);
    ~massiv();
    void max(int&, double&);
    void print();
    void delpset(int&);
    double lom();
};


massiv::massiv()
{
	printf("start constructor without parameters\n");
	printf("input size massiv : ");
	scanf("%5d",&m);
	y = new int[m];
	printf("input elements : ");
	for (int i=0;i<m;i++) scanf("%10d",&y[i]);
	printf("\nconstructor #1 exit\n");
}

massiv::massiv(int* tarray, int num)
{
	printf("start constructor with parameters\n");
	m = num;
	y = new int[m];
	for (int i=0;i<m;i++) y[i]=*(tarray+i);
	printf("constructor #2 exit\n");
}

massiv::~massiv()
{
	printf("destructor\n");
	delete[] y;
	printf("exit destructor\n");
};

void massiv::max(int &idx, double &value)
{
	int t;
	value=y[1]-(y[0]+y[2])/2;idx=-1;
	for (int i=2;i<(m-1);i++)
	{
		t=y[i]-(y[i-1]+y[i+1])/2;
		if (t>value) { idx=i; value=t; };
	};
}

void massiv::print()
{
	printf("\nprint array\n");
	for (int i=0;i<m;i++) printf("%5d",*(y+i));
	printf("\n");
}


void massiv::delpset(int &idx)
{
	printf("delete pset in array\n");
	m--;
	for (int i=idx;i<m;i++) *(y+i)=*(y+i+1);
}

double massiv::lom()
{
	double r=0;
	for(int i=0;i<(m-1);i++) r+=sqrt((y[i+1]-y[i])*(y[i+1]-y[i])+1);
	return r;
}

void main()
{
   clrscr();
   printf("start main()\n");
   printf("create first object\n");
   massiv v1;
   v1.print();
   int imax;
   double v,vv;
   v1.max(imax,v);
   if (imax==-1)
   {printf("no max\n");}
   else
   {
   printf("max #%5d = %5f\n",imax+1,v);
   v=v1.lom();printf("lom length %5f\n",v);
   v1.delpset(imax);
   };
   vv=v1.lom();printf("new lom length %5f\n",vv);
   v1.print();
   printf("create second object\n");
   randomize();
   int num=3+random(13);
   int *a = new int[num];
   for (int i=0;i<num;i++) *(a+i)=random(20);
   massiv v2(a, num);
   v2.print();
   v2.max(imax,v);
   v2.delpset(imax);
   v2.print();
   delete[] a;
   printf("exit main()\n");
}