#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

class Vector
{
  private:
    int *ar;
    int n;
  public:
    Vector();
    Vector(int*, int);
    ~Vector() { printf("\nstart Destructor\n");delete[] ar; printf("\nexit Destructor\n");};
    void Min(int&, int&);
    void Max(int&, int&);
    void Print();
    void Order();
};


Vector::Vector()
{
	printf("\nConstructor 1 without parameters\n");
	printf("Input size Array : ");
	scanf("%5d",&n);
	ar = new int[n];
	printf("Input elements...\n");
	for (int i=0;i<n;i++) scanf("%10d",&ar[i]);
	printf("\nThank you, constructor 1 exit");
}

Vector::Vector(int* a, int num)
{
	printf("\nConstructor 2 with parameters\n");
	n = num;
	ar = new int[n];
	for (int i=0;i<n;i++) ar[i]=*(a+i);
	printf("\nThank you, constructor 2 exit");
}

void Vector::Min(int &idx, int &value)
{
	value=*(ar);idx=0;
	for (int i=1;i<n;i++) if (*(ar+i)<value) { idx=i; value=*(ar+i); };
}

void Vector::Max(int &idx, int &value)
{
	value=*(ar);idx=0;
	for (int i=1;i<n;i++) if (*(ar+i)>value) { idx=i; value=*(ar+i); };
}

void Vector::Print()
{
	printf("\nArray\n");
	for (int i=0;i<n;i++) printf("%5d",*(ar+i));
}


void Vector::Order()
{
	printf("\nOrder array...\n");
	int nonodd=0;
	for (int i=0;i<n;i++)
	{
		if ((*(ar+i) % 2))
		{
			int te=*(ar+i);
			for (int j=i;j>nonodd;j--) *(ar+j)=*(ar+j-1);
			*(ar+nonodd)=te;
			nonodd++;
		}

	}
}

void main()
{
   clrscr();
   printf("Start main()\n");
   printf("\nCreate first object\n");
   Vector v1;
   v1.Print();
   int imin,v;
   v1.Min(imin,v);printf("\nmin #%5d = %5d\n",imin,v);
   int imax;
   v1.Max(imax,v);printf("\nmax #%5d = %5d\n",imax,v);
   v1.Order();
   v1.Print();
   v1.Min(imin,v);printf("\nmin #%5d = %5d\n",imin,v);
   v1.Max(imax,v);printf("\nmax #%5d = %5d\n",imax,v);
   printf("\nCreate second object\n");
   randomize();
   int num=1+random(15);
   int *a = new int[num];
   for (int i=0;i<num;i++) *(a+i)=random(20);
   Vector v2(a, num);
   v2.Print();
   v2.Order();
   v2.Print();
   delete[] a;
}