#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
class vector
{   int *a;
    int n;
  public:
    vector();
    vector(int);
    ~vector() { printf("\nstart DESTRUCTOR %04x:%04x\n",FP_SEG(this),FP_OFF(this));
		delete[] a; printf("\nexit Destructor\n");};
    void min(int&, int&);
    void max(int&, int&);
    void print();
    void order();
};


vector::vector()
{
	printf("\nstart CONSTRUCTOR #1 without parameters %04x:%04x\n",FP_SEG(this),FP_OFF(this));
	printf("-> input size vector : ");
	scanf("%5d",&n);
	a = new int[n];
	printf("-> input elements... : ");
	for (int i=0;i<n;i++) scanf("%10d",&a[i]);
	printf("\nthank you, CONSTRUCTOR #1 exit");
}

vector::vector(int num)
{
	printf("\nstart CONSTRUCTOR #2 with parameters %04x:%04x\n",FP_SEG(this),FP_OFF(this));
	n = num;
	a = new int[n];
	randomize();
	for (int i=0;i<n;i++) *(a+i)=random(20);
	printf("\nthank you, CONSTRUCTOR #2 exit");
}

void vector::min(int &idx, int &value)
{
	value=*(a);idx=0;
	for (int i=1;i<n;i++) if (*(a+i)<value) { idx=i; value=*(a+i); };
}

void vector::max(int &idx, int &value)
{
	value=*(a);idx=0;
	for (int i=1;i<n;i++) if (*(a+i)>value) { idx=i; value=*(a+i); };
}

void vector::print()
{
	printf("\nprint array\n");
	for (int i=0;i<n;i++) printf("%5d",*(a+i));
}


void vector::order()
{
	printf("\norder array...\n");
	int nonodd=0;
	for (int i=0;i<n;i++)
	{
		if ((*(a+i) % 2))
		{
			int te=*(a+i);
			for (int j=i;j>nonodd;j--) *(a+j)=*(a+j-1);
			*(a+nonodd)=te;
			nonodd++;
		}

	}
}

void main()
{
   printf("start main()\n");
   printf("\ncreate first object\n");
   vector v1;
   v1.print();
   int m,v;
   v1.min(m,v);printf("\nmin #%5d = %5d\n",m,v);
   v1.max(m,v);printf("\nmax #%5d = %5d\n",m,v);
   v1.order();
   v1.print();
   v1.min(m,v);printf("\nmin #%5d = %5d\n",m,v);
   v1.max(m,v);printf("\nmax #%5d = %5d\n",m,v);
   printf("\nCreate second object\n");
   printf("-> input size vector : ");scanf("%d",&num);
   vector v2(num);
   v2.print();
   v2.order();
   v2.print();
}