#include <iostream.h>
#include <stdlib.h>
#include <conio.h>

class matrix
{
  private:
  int *ar,n;
  public:
    matrix();
    matrix(int);
    ~matrix();
    matrix operator=(matrix&);
    matrix operator-(matrix&);
    friend void order(matrix&);
    friend void print(matrix&);
};

matrix::matrix()
{
  randomize();
  n=random(7);
  double x;
  ar=new int [n*n];
  for (int i=0;i<n;i++)
  { for (int j=0;j<n;j++)
    {  x=(random(11))/10.0;
       if (x<0.4) *(ar+i*n+j)=0; else *(ar+i*n+j)=1;
    };
  };
  cout<<"constructor: matrix is complete\n";
};

matrix::matrix(int tmpn)
{
  randomize();
  n=tmpn;
  double x;
  ar=new int [n*n];
  for (int i=0;i<n;i++)
  { for (int j=0;j<n;j++)
    {  x=(random(11))/10.0;
       if (x<0.4) *(ar+i*n+j)=0; else *(ar+i*n+j)=1;
    };
  };
  cout<<"constructor: matrix is complete\n";
};
matrix::~matrix() {delete[] ar;cout<<"destructor: matrix destroyed\n";};

matrix matrix::operator=(matrix& ar2)
{
	for (int i=0;i<n;i++)
	  for(int j=0;j<n;j++)
	   (*(ar+n*i+j))=(*(ar2.ar+n*i+j));
	return *this;
};

matrix matrix::operator-(matrix& ar2)
{
	for (int i=0;i<n;i++)
	  for(int j=0;j<n;j++)
	    *(ar+i*n+j)=(*(ar+i*n+j))-(*(ar2.ar+i*n+j));
	return *this;
};


void print(matrix &x)
{  int i,j;
   cout<<"print matrix...\n";
   for (i=0;i<x.n;i++) { for (j=0;j<x.n;j++) cout<<*(x.ar+i*x.n+j)<<"   ";cout<<endl; };
};


void order(matrix &x)
{
   int lt=0,lb=0,rt=0,rb=0;
   if (*x.ar) 			lt=1;
   if (*(x.ar+(x.n-1)*x.n))	lb=1;
   if (*(x.ar+x.n-1)) 		rt=1;
   if (*(x.ar+x.n*x.n-1)) 	rb=1;
   int i,j,kj=1,tmp;
   if (lt && lb) goto l1;
   for (j=0;j<x.n;j++)
     if ( (*(x.ar+j)) && (*(x.ar+x.n*j+j)))
     {
	if (j != 0)
	{
		kj=j;
		for (i=0;i<x.n;i++)
		{
			tmp=*(x.ar+i*x.n);
			*(x.ar+i*x.n)=*(x.ar+i*x.n+j);
			*(x.ar+i*x.n+j)=tmp;
		}
		goto l1;
	}
     }
   l1:
   if (rt && rb) goto l2;
   for (j=kj;j<x.n;j++)
     if ( (*(x.ar+j)) && (*(x.ar+x.n*j+j)))
     {
	if (j != (x.n-1))
	{
		for (i=0;i<x.n;i++)
		{
			tmp=*(x.ar+i*(x.n-1));
			*(x.ar+i*(x.n-1))=*(x.ar+i*x.n+j);
			*(x.ar+i*x.n+j)=tmp;
		}
		goto l2;
	}
     }
   l2:
};


void main()
{
   clrscr();
   randomize();cout<<"Input n : ";int tmpn;cin>>tmpn;
   matrix a1(tmpn);
   print(a1);
//   order(a1);
//   print(a1);
   cout<<"\n";
   matrix a2(tmpn);
   print(a2);
   matrix a3(tmpn);             &
   a3=a1-a2;
   cout<<"\n";
   print(a3);
   getch();
}