#include <iostream.h>
#include <graphics.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
class Shape {
public:
	int color;
	virtual void draw()=0;
	virtual void hide() {setcolor(getbkcolor());};
};
class Circle:public Shape {
private:int 	radius;
	int 	x,y;
public :Circle();
	Circle(int, int, int, int); // center, radius, color
	void 	draw() 	{ setcolor(color);circle(x,y,radius); };
	void 	hide() 	{ setcolor(getbkcolor());circle(x,y,radius);};
	void 	move(int,int);
	void	Setcolor(char c) {color=c;};
	int	Getradius() {return radius;};
	void	Setradius(int r) {radius=r;};
};
Circle::Circle()
{
	x	=random(getmaxx());
	y	=random(getmaxy());
	radius	=random(getmaxx()/40);
	color	=random(getmaxcolor());
}
Circle::Circle(int myx, int myy, int r, int c)
{
	x	=myx;
	y	=myy;
	radius	=r;
	color	=c;
};
void Circle::move(int myx,int myy)
{
	x=(x+myx) % getmaxx();
	y=(y+myy) % getmaxy();
}
void main()
{
	randomize();
	int gdriver = DETECT, gmode, errorcode;
	initgraph(&gdriver, &gmode, "");
	const int maxc=30;
	Circle arcircle[maxc];
	while (!kbhit())
	{
		for (int i=0;i<maxc;i++) arcircle[i].draw();
		delay(100);
		for (i=0;i<maxc;i++) arcircle[i].hide();
		for (i=0;i<maxc;i++)
		{
			arcircle[i].move(20,0);
			arcircle[i].Setcolor(random(256));
			arcircle[i].Setradius(arcircle[i].Getradius()+3);
		}

	}
	getch();
	closegraph();
}