#include <iostream.h>
#include <graphics.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
class Shape {
public:
	int color;
	virtual void draw()=0;
	virtual void hide() {setcolor(getbkcolor());};
};
class Rectangle:public Shape {
private:int 	x1,y1,x2,y2;
public :Rectangle();
	Rectangle(int, int, int, int, int); // left, top, right, bottom, color
	void 	draw() 	{ setcolor(color);rectangle(x1,y1,x2,y2); };
	void 	hide() 	{ setcolor(getbkcolor());rectangle(x1,y1,x2,y2);};
	void 	move(int,int);
	void	Setcolor(char c) {color=c;};
};
Rectangle::Rectangle()
{
	x1	=random(getmaxx());
	y1	=random(getmaxy());
	x2	=x1+random(50);
	y2	=y1+random(50);
	color	=random(getmaxcolor());
}
Rectangle::Rectangle(int myx1, int myy1, int myx2, int myy2,int mc)
{
	x1	=myx1;
	y1	=myy1;
	x2	=myx2;
	y2	=myy2;
	color=mc;

};
void Rectangle::move(int myx,int myy)
{
	x1=(x1+myx) % getmaxx();
	y1=(y1+myy) % getmaxy();
	x2=(x2+myx) % getmaxx();
	y2=(y2+myy) % getmaxy();
}
void main()
{
	randomize();
	int gdriver = DETECT, gmode, errorcode;
	initgraph(&gdriver, &gmode, "");
	const int maxc=30;
	Rectangle arr[maxc];
	while (!kbhit())
	{
		for (int i=0;i<maxc;i++) arr[i].draw();
		delay(100);
		for (i=0;i<maxc;i++) arr[i].hide();
		for (i=0;i<maxc;i++) arr[i].move(0,10);

	}
	getch();
	closegraph();
}